# Copyright (c) Microsoft Corporation. 
# Licensed under the MIT license. 

import math
import os
import sys
import glob
import gc
import threading

from pathlib import Path
from simplygon import simplygon_loader
from simplygon import Simplygon


def RunReduction(sg: Simplygon.ISimplygon):
    sgSceneImporter = sg.CreateSceneImporter()
    sgSceneImporter.SetImportFilePath( "../Assets/RiggedSimplygonMan/RiggedSimplygonMan.fbx" )
    if not sgSceneImporter.RunImport():
        raise Exception("Failed to load RiggedSimplygonMan/RiggedSimplygonMan.fbx.")
    sgScene = sgSceneImporter.GetScene()

    # Create the reduction pipeline. 
    sgReductionPipeline = sg.CreateReductionPipeline()

    sgReductionSettings = sgReductionPipeline.GetReductionSettings()
    sgNormalCalculationSettings = sgReductionPipeline.GetNormalCalculationSettings()

    # Set reduction target to triangle ratio with a ratio of 50%. 
    sgReductionSettings.SetReductionTargets( Simplygon.EStopCondition_All, True, False, False, False )
    sgReductionSettings.SetReductionTargetTriangleRatio( 0.5 )

    # The angle in degrees determing the normal smoothness. 
    sgNormalCalculationSettings.SetHardEdgeAngle( 75 )

    # Reorthogonalize the tangentspace after the reduction. 
    sgNormalCalculationSettings.SetReorthogonalizeTangentSpace( True )

    # Repair invalid normals. 
    sgNormalCalculationSettings.SetRepairInvalidNormals( True )

    # Don't generate new normals. However invalid normals will still be repaired. 
    sgNormalCalculationSettings.SetReplaceNormals( False )

    # Don't generate new tangents and bitangents. 
    sgNormalCalculationSettings.SetReplaceTangents( False )

    # Scale the vertex normal based on the triangle area. 
    sgNormalCalculationSettings.SetScaleByAngle( False )
    sgNormalCalculationSettings.SetScaleByArea( True )

    # Don't snap the normal to flat surfaces. 
    sgNormalCalculationSettings.SetSnapNormalsToFlatSurfaces( False )

    # Start the reduction pipeline. 
    sgReductionPipeline.RunScene(sgScene, Simplygon.EPipelineRunMode_RunInThisProcess)

    # Get the processed scene. 
    sgProcessedScene = sgReductionPipeline.GetProcessedScene()

    sgSceneExporter = sg.CreateSceneExporter()
    sgSceneExporter.SetScene(sgProcessedScene)
    sgSceneExporter.SetExportFilePath( "ReductionOutput.fbx" )
    if not sgSceneExporter.RunExport():
        raise Exception("Failed to save ReductionOutput.fbx.")


if __name__ == '__main__':
    sg = simplygon_loader.init_simplygon()

    RunReduction(sg)

    sg = None
    gc.collect()

